package test.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URLEncoder;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class CookieTest2 extends HttpServlet {

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		//パラメータを取得する
		String username = req.getParameter("username");
		String name = req.getParameter("name");
		String email = req.getParameter("email");
		String save = req.getParameter("save");

		//受信したデータをUTF-8に変換する
		username = new String(username.getBytes("8859_1"), "UTF-8");
		name = new String(name.getBytes("8859_1"), "UTF-8");
		email = new String(email.getBytes("8859_1"), "UTF-8");

		//Cookie仁保損するデータをURLエンコードにかける
		username = URLEncoder.encode(username, "utf-8");
		name = URLEncoder.encode(name, "utf-8");
		email = URLEncoder.encode(email, "utf-8");

		//クッキーを準備する
		Cookie uncookie = new Cookie("UserName", username);
		Cookie ncookie = new Cookie("Name", name);
		Cookie ecookie = new Cookie("Email", email);

		//情報を保存するかどうかで分岐する
		if(save != null && save.equals("save")){
			//クッキーの有効期限を未来にセットする
			uncookie.setMaxAge(60*60*24*30);
			ncookie.setMaxAge(60*60*24*30);
			ecookie.setMaxAge(60*60*24*30);
		}else{
			//クッキーの有効期限を未来にセットする
			uncookie.setMaxAge(-1);
			ncookie.setMaxAge(-1);
			ecookie.setMaxAge(-1);
		}

		//各クッキーを送信する準備をする
		resp.addCookie(uncookie);
		resp.addCookie(ncookie);
		resp.addCookie(ecookie);

		//クライアントに出力する準備
		resp.setContentType("text/html; charset=utf-8");
		PrintWriter pw = resp.getWriter();

		//クライアントにHTMLタグを書き出す
		pw.println("<html>");
		pw.println("<head>");
		pw.println("<title>クッキーに保存</title>");
		pw.println("</head>");
		pw.println("<body>");
		pw.println("  クッキーに保存しました。<br>");
		pw.println("  <a href='CookieTest2.jsp'>もどる</a>");
		pw.println("</body>");
		pw.println("</html>");
	}

}
